/*
 *     Dependence.java  Dec 18, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.platform.xml.graph.pdg;
import org.jtool.platform.xml.graph.*;
import org.jtool.platform.xml.wrapper.*;

public class Dependence extends GraphEdge {
    protected Dependence() {
    }

    public Dependence(PDGNode src, PDGNode dst) {
        super(src, dst);
    }

    public boolean equals(GraphComp comp) {
        GraphEdge edge = (GraphEdge)comp;
        if (this == edge) {
            return true;
        }
        return sort == edge.getSort()
            && src.equals(edge.getSrcNode()) && dst.equals(edge.getDstNode());
    }

    public boolean isCD() {
        return sort / 10 == CDs;
    }

    public boolean isDD() {
        return sort / 10 == DDs;
    }

    public void print() {
        System.out.println(src.getId() + " -> " + dst.getId());
    }

    public void print(StringBuffer buf) {
        buf.append(src.getId() + " -> " + dst.getId() + "\n");
    }

    public void write(StringBuffer buf) {
        buf.append("    <edge src=\"" + src.getId() + "\" dst=\"" + dst.getId() + "\"");
        buf.append(" sort=\"" + sort + "\">");
        if (isDD()) {
            DD dd = (DD)this;
            JavaVariable jv = dd.getVariable();
            buf.append("<var id=\"" + jv.getElemId() + "\"");
            buf.append(" name=\"" + jv.getName() + "\"");

            if (dd.isLoopCarried()) {
                buf.append(" lc=\"" + dd.getLoopCarriedNode().getId() + "\"");
            }
            buf.append("/>");
        }
        buf.append("</edge>\n");
    }
}
